Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!

Bug 531656

Summary: sys-apps/portage-2.2.15: dev-lang/ocaml-4.02.1 - slot conflict with ocaml-4.01.0 pulled in by dev-ml/lablgl deps: || ( dev-ml/labltk:= <dev-lang/ocaml-4.02[tk] )
Product: Gentoo Linux Reporter: Juergen Rose <rose>
Component: Current packagesAssignee: Portage team <dev-portage>
Status: RESOLVED FIXED    
Severity: normal CC: cbatdotcom, esigra, ml
Priority: Normal Keywords: InVCS
Version: unspecified   
Hardware: All   
OS: Linux   
See Also: https://bugs.gentoo.org/show_bug.cgi?id=554838
https://bugs.gentoo.org/show_bug.cgi?id=692746
Whiteboard:
Package list:
Runtime testing required: ---
Bug Depends on:    
Bug Blocks: 300071, 484436    

Description Juergen Rose 2014-12-04 11:44:50 UTC
'emerge --update --newuse --deep --with-bdeps=y --backtrack=30 @world' fails with:
...
Calculating dependencies... done!
...
[ebuild     U  ] dev-lang/ocaml-4.02.1 [4.01.0]
[ebuild     U  ] dev-ml/findlib-1.5.5-r1 [1.5.5]
...
[ebuild     U  ] dev-python/ipython-2.3.1 [2.3.0]

!!! Multiple package instances within a single package slot have been pulled
!!! into the dependency graph, resulting in a slot conflict:

dev-lang/ocaml:0

  (dev-lang/ocaml-4.01.0:0/4.01.0::gentoo, installed) pulled in by
    >=dev-lang/ocaml-3.10.2:0/4.01.0=[ocamlopt] required by (dev-ml/camlidl-1.05-r1:0/1.05::gentoo, installed)
                           ^^^^^^^^^^                                                                                                             
    <dev-lang/ocaml-4.02.0 required by (dev-ml/lablgl-1.05:0/1.05::gentoo, installed)
    ^               ^^^^^^                                                                                                                  
    (and 4 more with the same problems)

  (dev-lang/ocaml-4.02.1:0/4.02.1::gentoo, ebuild scheduled for merge) pulled in by
    >=dev-lang/ocaml-4.02.1:=[ocamlopt?] required by (dev-ml/findlib-1.5.5-r1:0/0::gentoo, ebuild scheduled for merge)
    ^^               ^^^^^^       
...



root@caiman:/root(31)# emerge --info  ocaml
Portage 2.2.15 (python 2.7.8-final-0, default/linux/amd64/13.0, gcc-4.8.3, glibc-2.20, 3.17.4-gentoo x86_64)
=================================================================
                         System Settings
=================================================================
System uname: Linux-3.17.4-gentoo-x86_64-AMD_Phenom-tm-_II_X6_1090T_Processor-with-gentoo-2.2
KiB Mem:    16177736 total,   1411320 free
KiB Swap:  100663280 total, 100663280 free
Timestamp of tree: Thu, 04 Dec 2014 08:00:01 +0000
sh bash 4.3_p30-r1
ld GNU ld (GNU Binutils) 2.24
app-shells/bash:          4.3_p30-r1
dev-java/java-config:     2.2.0
dev-lang/perl:            5.20.1-r3
dev-lang/python:          2.7.8, 3.3.5-r1, 3.4.2
dev-util/cmake:           3.0.2
dev-util/pkgconfig:       0.28-r2
sys-apps/baselayout:      2.2
sys-apps/openrc:          0.13.6
sys-apps/sandbox:         2.6-r1
sys-devel/autoconf:       2.13, 2.69
sys-devel/automake:       1.10.3-r1, 1.11.6-r1, 1.12.6, 1.13.4, 1.14.1
sys-devel/binutils:       2.24-r3
sys-devel/gcc:            4.8.3
sys-devel/gcc-config:     1.8
sys-devel/libtool:        2.4.3-r2
sys-devel/make:           4.1-r1
sys-kernel/linux-headers: 3.17-r1 (virtual/os-headers)
sys-libs/glibc:           2.20
Repositories: gentoo x11 science sunrise sage-on-gentoo x-portage g-cpan g-octave
ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="* -@EULA PUEL Intel-SDP dlj-1.1 skype-eula skype-4.0.0.7-copyright googleearth AdobeFlash-11.x cadsoft Oracle-BCLA-JavaSE MakeMKV-EULA NVIDIA-CUDA Nero-AAC-EULA GIMPS"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=amdfam10 -O2 -pipe"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/config /usr/share/gnupg/qualified.txt /var/lib/hsqldb"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php5.6/ext-active/ /etc/php/cgi-php5.6/ext-active/ /etc/php/cli-php5.6/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-march=amdfam10 -O2 -pipe"
DISTDIR="/usr/portage/distfiles"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs config-protect-if-modified distlocks ebuild-locks fixlafiles merge-sync news parallel-fetch preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://distfiles.gentoo.org"
LANG="en_US.UTF-8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j7"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage_caiman"
PORTDIR_OVERLAY="/var/lib/layman/x11 /var/lib/layman/science /var/lib/layman/sunrise /var/lib/layman/sage-on-gentoo /usr/local/portage /var/lib/cpan /var/lib/g-octave"
USE="3dnow 3dnowext 64bit R X Xaw3d a52 aac acl acpi admin afs alsa amd64 ao apache2 apng applet archive armadillo arpack asf aspell atlas audacious audiofile automap automount bash-completion berkdb blas blast bluetooth bluray boost bzip2 cairo cdda cddb cdf cdio cdparanoia cdr cgi chm cli cmake cracklib crypt css cups curl cxx daap db dbi dbm dbus declarative designer devhelp device-mapper dga dia dirac djvu doc dot dri ds2490 ds9097 ds9097u dts dv dvb dvd dvdr dvi dynamicplugin eds egl elf emacs emboss emf encode epiphany evo examples exif expat extensions extra extras faac faad fam ffmpeg fftw firefox fits flac fltk fontconfig foomaticdb fortran fortran95 fpm fpx fuse g3dvl gcj gd gdal gdbm gdu gedit geoip geolocation geos gfortran gif gimp git glade glib glpk gml gmp gnome gnome-keyring gnome-print gnuplot gnutls gold gphoto2 gpm grammar graphics graphtft graphviz grass gsl gsm gstreamer gtk gtk3 gudev guile hddtemp hdf hdf5 hdri html http httpd hvm hwdb iconv icq icu id3tag ide imagemagick imap inotify introspection ipod ipv6 irda ithreads jabber jadetex java java6 jbig jit john jpeg jpeg2k kate kdepim kdrive kerberos keymap kpathsea kvm ladspa lame lapack latex lcms ldap lensfun libffi libkms libnotify libsamplerate live lm_sensors lua lzma lzo mad mail maildir mapnik math matroska media-library mercurial mikmod mkl mmx mmxext mng mod modules mono motif mozilla mp3 mp4 mpeg mpi mplayer mtp multilib multimedia musepack musicbrainz mysql mysqli nautilus ncurses netcdf netpbm network networking nfs nls nntp nptl nsplugin ntfs ntp numpy obex objc ocaml ocr octave odbc ofa ogdi ogg openexr opengl openmp openvg pam pango pcre pda pdf pdl2 perl plasma plotutils plugins png podcast policykit portaudio posix postgres postscript ppds preview-latex proj projectm pstricks pulseaudio python python-bindings q16 q32 qemu qhull qt3support qt4 quicktime raw readline reiserfs reports rle romio rpc rrdcgi rrdtool sage samba sasl schroedinger science sdk sdl secure-delete semantic-desktop server session shout sip slang slp smart smbclient smp sms sndfile snmp soap sockets sound soup sox speex spell sql sqlite sse sse2 sse4 sse4a ssl stlport subtitles subversion sudo suexec svg svm swig systemd szip t1lib tcl tcpd tex tex4ht texmacs theora thesaurus threads thunderbird tidy tiff tk toolbar tools truetype udev udisks unicode usb utempter v4l vaapi vala valgrind vdpau video virt-network virtualbox visio vorbis vpx vtk wav webdav webdav-serf webkit wmf wxwidgets x264 xa xattr xcb xetex xext xft xine xml xmlreader xmlrpc xpm xv xvid xvmc yaml youtube zlib zvbi" ABI_X86="64" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" APACHE2_MODULES="actions alias auth_basic auth_digest authn_anon authn_dbd authn_core authn_dbm authn_default authn_file authz_core authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgid dav dav_fs dav_lock dbd deflate dir disk_cache env expires ext_filter file_cache filter headers ident imagemap include info lbmethod_byrequests log_config logio mem_cache mime mime_magic negotiation proxy proxy_ajp proxy_balancer proxy_connect proxy_http rewrite setenvif slotmem_shm so socache_shmcb speling status unique_id unixd userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" CAMERAS="canon fuji ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CURL_SSL="nss" DRACUT_MODULES="caps lvm mdraid syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="keyboard mouse evdev void" KERNEL="linux" LCD_DEVICES="cfontz hd44780 mtxorb ncurses X lcd2usb lcdlinux png usblcd" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LINGUAS="de fr ru" NETBEANS_MODULES="apisupport cnd dlight enterprise ergonomics groovy gsf harness ide identity j2ee java mobility nb php profiler websvccommon xml" OFFICE_IMPLEMENTATION="libreoffice" PYTHON_SINGLE_TARGET="python2_7" PYTHON_TARGETS="python2_7 python3_3" QEMU_SOFTMMU_TARGETS="arm i386 x86_64" QEMU_USER_TARGETS="arm i386 x86_64" RUBY_TARGETS="ruby19 ruby20" USERLAND="GNU" VIDEO_CARDS="radeon displaylink" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, SYNC, USE_PYTHON

=================================================================
                        Package Settings
=================================================================

dev-lang/ocaml-4.01.0 was built with the following:
USE="X emacs latex ncurses ocamlopt -tk -xemacs" ABI_X86="64"
Comment 1 Alexis Ballier gentoo-dev 2014-12-04 11:54:46 UTC
sounds like a portage "bug": it should prefer dev-ml/camlp4 (leftmost part of the || ) for lablgl when ocaml-4.02 is pulled in for other reasons
Comment 2 Juergen Rose 2014-12-04 13:16:26 UTC
BTW., already 'emerge -v1 findlib' fails with:

root@caiman:/root(35)# emerge -v1 findlib 

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild     U  ] dev-lang/ocaml-4.02.1:0/4.02.1 [4.01.0:0/4.01.0] USE="X emacs latex ncurses ocamlopt -xemacs (-tk%)" 1,984 KiB
[ebuild     U  ] dev-ml/findlib-1.5.5-r1 [1.5.5] USE="doc ocamlopt -tk" 0 KiB

Total: 2 packages (2 upgrades), Size of downloads: 1,984 KiB

!!! Multiple package instances within a single package slot have been pulled
!!! into the dependency graph, resulting in a slot conflict:

dev-lang/ocaml:0

  (dev-lang/ocaml-4.02.1:0/4.02.1::gentoo, ebuild scheduled for merge) pulled in by
    >=dev-lang/ocaml-4.02.1:=[ocamlopt?] required by (dev-ml/findlib-1.5.5-r1:0/0::gentoo, ebuild scheduled for merge)
    ^^               ^^^^^^ 

  (dev-lang/ocaml-4.01.0:0/4.01.0::gentoo, installed) pulled in by
    >=dev-lang/ocaml-3.10.2:0/4.01.0=[ocamlopt] required by (dev-ml/camlidl-1.05-r1:0/1.05::gentoo, installed)
                           ^^^^^^^^^^                                                                                                             
    <dev-lang/ocaml-4.02.0 required by (dev-ml/lablgl-1.05:0/1.05::gentoo, installed)
    ^               ^^^^^^                                                                                                                  
    (and 4 more with the same problems)
Comment 3 Zac Medico gentoo-dev 2014-12-05 16:10:26 UTC
The dep_zapdeps function needs some new heuristics to handle || ( dev-ml/labltk:= <dev-lang/ocaml-4.02[tk] ) deps from dev-ml/lablgl-1.05. The new heuristics can make use of the _want_update_pkg method to detect whether a dev-lang/ocaml upgrade is desired, and avoid the <dev-lang/ocaml-4.02[tk] choice in that case.
Comment 4 Juergen Rose 2014-12-10 09:18:24 UTC
Now I have this slot conflict only on systems with app-text/kbibtex-0.5.1 (depending on dev-tex/bibtex2html-1.98).
'emerge --update --newuse --deep --with-bdeps=y --backtrack=30 @world' fails with:


root@lynx:/root(36)# emerge --update --newuse --deep --with-bdeps=y --backtrack=30 @world

 * IMPORTANT: 1 news items need reading for repository 'gentoo'.
 * Use eselect news to read news items.

Calculating dependencies... done!
[ebuild     UD ] dev-lang/ocaml-4.01.0 [4.02.1] USE="-tk%" 
...

!!! Multiple package instances within a single package slot have been pulled
!!! into the dependency graph, resulting in a slot conflict:

dev-lang/ocaml:0

  (dev-lang/ocaml-4.02.1:0/4.02.1::gentoo, installed) pulled in by
    >=dev-lang/ocaml-3.10:0/4.02.1=[ocamlopt] required by (dev-ml/lablgtk-2.18.3:2/2.18.3::gentoo, installed)
                         ^^^^^^^^^^                                                                                                              
    >=dev-lang/ocaml-4.02.1:=[ocamlopt?] required by (dev-ml/findlib-1.5.5-r1:0/0::gentoo, installed)
    ^^               ^^^^^^                                                                                                                                                    
    (and 7 more with the same problems)

  (dev-lang/ocaml-4.01.0:0/4.01.0::gentoo, ebuild scheduled for merge) pulled in by
    >=dev-lang/ocaml-3.10:0/4.01.0=[ocamlopt] required by (dev-tex/bibtex2html-1.98:0/0::gentoo, installed)
                         ^^^^^^^^^^
...


'emerge -v1 =ocaml-4.01.0' fails with:

root@lynx:/root(38)# emerge -v1 =ocaml-4.01.0

 * IMPORTANT: 1 news items need reading for repository 'gentoo'.
 * Use eselect news to read news items.


These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild     UD ] dev-lang/ocaml-4.01.0:0/4.01.0 [4.02.1:0/4.02.1] USE="X emacs latex ncurses ocamlopt -tk% -xemacs" 0 KiB

Total: 1 package (1 downgrade), Size of downloads: 0 KiB

!!! Multiple package instances within a single package slot have been pulled
!!! into the dependency graph, resulting in a slot conflict:

dev-lang/ocaml:0

  (dev-lang/ocaml-4.01.0:0/4.01.0::gentoo, ebuild scheduled for merge) pulled in by
    =dev-lang/ocaml-4.01.0 (Argument)

  (dev-lang/ocaml-4.02.1:0/4.02.1::gentoo, installed) pulled in by
    >=dev-lang/ocaml-4.02:=[ocamlopt?] required by (dev-ml/camlp4-4.02.0_p1-r1:0/4.02.0_p1::gentoo, installed)
    ^^               ^^^^                                                                                                                                                               
    >=dev-lang/ocaml-3.10:0/4.02.1=[ocamlopt] required by (dev-ml/lablgtk-2.18.3:2/2.18.3::gentoo, installed)
                         ^^^^^^^^^^                                                                                                              
    (and 4 more with the same problems)

...
Comment 5 Zac Medico gentoo-dev 2014-12-20 18:31:07 UTC
(In reply to Juergen Rose from comment #4)
> Now I have this slot conflict only on systems with app-text/kbibtex-0.5.1

This appears to be a separate issue, because it does not involve the || ( dev-ml/labltk:= <dev-lang/ocaml-4.02[tk] ) deps from dev-ml/lablgl-1.05.

Please file a new bug.
Comment 6 Zac Medico gentoo-dev 2014-12-21 06:53:48 UTC
(In reply to Zac Medico from comment #3)
> The dep_zapdeps function needs some new heuristics to handle || (
> dev-ml/labltk:= <dev-lang/ocaml-4.02[tk] ) deps from dev-ml/lablgl-1.05. The
> new heuristics can make use of the _want_update_pkg method to detect whether
> a dev-lang/ocaml upgrade is desired, and avoid the <dev-lang/ocaml-4.02[tk]
> choice in that case.

In the following branch I have a test case to reproduce the problem:

	https://github.com/zmedico/portage/commits/bug_531656

I also started working on some heuristics to help it converge on the desired solution, but the changes currently break SlotConflictUpdateTestCase.
Comment 7 Zac Medico gentoo-dev 2014-12-26 05:02:04 UTC
In my bug_531656 branch on github I have a patch which I've posted for review here:

	http://thread.gmane.org/gmane.linux.gentoo.portage.devel/5040
Comment 8 Zac Medico gentoo-dev 2015-01-05 19:47:41 UTC
This is in the master branch now:

https://github.com/gentoo/portage/commit/a9064d08ef4c92a5d0d1bfb3dc8a01b7850812b0
Comment 9 Arve Barsnes 2015-02-11 18:45:25 UTC
There MIGHT still be an issue here in portage-2.2.16. I still had blockers from dev-ml/lablgl and dev-ml/lablgtk for various emerge commands I tried to get these upgrades through. It got resolved for me only after explicitly running

emerge -1va camlp4 ocaml findlib lablgl lablgtk

BUT! I didn't run

emerge --update --newuse --deep --with-bdeps=y @world

again until later, and this command might have figured out how to proceed, too late to find out for me now. I'm not 100% clear on what the patch would do, if anything, for my regular emerge commands.
Comment 10 Zac Medico gentoo-dev 2015-02-11 18:48:50 UTC
(In reply to arve.barsnes@gmail.com from comment #9)
> There MIGHT still be an issue here in portage-2.2.16. I still had blockers
> from dev-ml/lablgl and dev-ml/lablgtk for various emerge commands I tried to
> get these upgrades through. It got resolved for me only after explicitly
> running
> 
> emerge -1va camlp4 ocaml findlib lablgl lablgtk
> 
> BUT! I didn't run
> 
> emerge --update --newuse --deep --with-bdeps=y @world

This is expected. For best results, you really need to do a full @world update.
Comment 11 Arve Barsnes 2015-02-13 09:03:22 UTC
I suspected as much, thanks.
Comment 12 Brian Dolbec gentoo-dev 2015-02-15 05:34:34 UTC
Released in portage-2.2.16.